'\" $Id: cisamperl.man,v 0.9 1994/10/31 07:10:44 mathias Exp $
'\"
'\"	(C) 1993,1994 Mathias Koerber (Mathias.Koerber@swi.com.sg)
'\"	please see accompanying file COPYRIGHT for details on copyright
'\"	and copying/(re-)distribution.
'\"
'\" $Log: cisamperl.man,v $
# Revision 0.9  1994/10/31  07:10:44  mathias
# *** empty log message ***
#
'\"
.\" -*- nroff -*-
.rn '' }`
'\" $Log: cisamperl.man,v $
# Revision 0.9  1994/10/31  07:10:44  mathias
# *** empty log message ***
#
.de Sh
.br
.ne 5
.PP
\fB\\$1\fR
.PP
..
.de Sp
.if t .sp .5v
.if n .sp
..
'\"
'\"     Set up \*(-- to give an unbreakable dash;
'\"     string Tr holds user defined translation string.
'\"     Bell System Logo is used as a dummy character.
'\"
.ie n \{\
.tr \(*W-\*(Tr
.ds -- \(*W-
.if (\n(.H=4u)&(1m=24u) .ds -- \(*W\h'-12u'\(*W\h'-12u'-\" diablo 10 pitch
.if (\n(.H=4u)&(1m=20u) .ds -- \(*W\h'-12u'\(*W\h'-8u'-\" diablo 12 pitch
.ds L" ""
.ds R" ""
.ds L' '
.ds R' '
'br \}
.el \{\
.ds -- \(em\|
.tr \*(Tr
.ds L" ``
.ds R" ''
.ds L' `
.ds R' '
'br\}
.TH CISAMPERL 1 PERL-TOOLS
.SH NAME
cisamperl - perl binary with cisam functions
.SH SYNOPSIS
.B cisamperl
[usual perl options and parameters]
.sp
.B rocisperl
[usual perl options and parameters]
.SH DESCRIPTION
.I cisamperl
is a perl binary extended to handle C-ISAM files through
.B usub
routines. 
.sp
.I rocisperl
is a version of 
.I cisamperl 
stripped of all commands that could update a C-ISAM file. It is intended
as a version that can be distributed to endusers for reporting purposes,
without giving them the chance to modify or destroy data accidentally. It
is also useful for testing and teaching about cisamperl. (For more info
on distributing
.I rocisperl
see the section 
.B COPYRIGHT and DISTRIBUTION
below).
.sp
.I cisamperl
has to be built by the user by combining the cisamperl
distribution (consisting of only the C-ISAM usub stuff) with a regular
.B perl
distribution (which may or may not be included in the package) and
a C-ISAM library (
.B NOT 
included) to make an executable.
.sp
.SH FUNCTIONS
This sections outlines the functions
.I cisamperl
provides to access C-ISAM files. Basically these are the same functions
available in the C-ISAM library. Due to the nature of perl's string
handling, routines that take a pointer 
.B into
a buffer as a parameter in C-ISAM, need two parameters in
.I cisamperl,
namely the buffer and an offset.
.br
Example:
.br
The C-ISAM function
.br
.B 	ldint(p)
.br
	char *p;
.sp
is implemented in
.I cisamperl
as
.br
.B 	sub ldint {
.br
	local(buffer,offset) = @_;
.sp
where buffer is the perl scalar holding the whole buffer (as obtained from
an 
.B &isread
) and offset is the numerical offset into that buffer.
.sp
In contrast to this, functions that require whole buffers (like 
.B iswrite
and 
.B isread
) also just require the buffer as variable in
.I cisamperl.
.sp
Here now all functions:
.sp
.B &isaddindex($isfd, $keydesc)
.sp
.B &isaudit($isfd, $filename, $mode)
.sp
.B &isbegin()
.sp
.B &isbuild($filename, $reclen, $keydesc, $mode)
.sp
.B &isclose($isfd)
.sp
.B &iscluster($isfd, $keydesc)
.sp
.B &iscommit()
.sp
.B &isdelcurr($isfd)
.sp
.B &isdelete($isfd, $record)
.sp
.B &isdelindex($isfd, $keydesc)
.sp
.B &isdelrec($isfd, $recnum)
.sp
.B &iserase($filename)
.sp
.B &isflush($isfd)
.sp
.B &isindexinfo($isfd, $buffer, $ixnumber)
.sp
.B &islock($isfd)
.sp
.B &islogclose()
.sp
.B &islogopen($logname)
.sp
.B &isopen($filename, $mode)
.sp
.B &isread($isfd, $record, $mode)
.sp
.B &isrecover()
.sp
.B &isrelease($isfd)
.sp
.B &isrename($oldname, $newname)
.sp
.B &isrewcurr($isfd, $record)
.sp
.B &isrewrec($isfd, $recnum, $record)
.sp
.B &isrewrite($isfd, $record)
.sp
.B &isrollback()
.sp
.B &issetunique($isfd, $uniqueid)
.sp
.B &isstart($isfd, $keydesc, $length, $record, $mode)
.sp
.B &isuniqueid($isfd, $uniqueid)
.sp
.B &isunlock($isfd)
.sp
.B &iswrcurr($isfd, $record)
.sp
.B &iswrite($isfd, $record)
.sp
.B &ldchar($fstr, $offset, $length, $cstr)
.sp
.B &lddbl($p, $offset)
.sp
.B &lddblnull($p, $offset, $nullflag)
.sp
.B &lddecimal($cp, $offset, $len, $decp)
.sp
.B &ldfloat($p, $offset)
.sp
.B &ldfltnull($p, $offset, $nullflag)
.sp
.B &ldint($p, $offset)
.sp
.B &ldlong($p, $offset)
.sp
.B &stchar($cstr, $fstr, $offset, $length)
.sp
.B &stdbl($d, $p, $offset)
.sp
.B &stdblnull($d, $p, $offset, $nullflag)
.sp
.B &stdecimal($decp, $cp, $offset, $len)
.sp
.B &stfloat($f, $p, $offset)
.sp
.B &stfltnull($f, $p, $offset, $nlflg)
.sp
.B &stint($i, $p, $offset)
.sp
.B &stlong($l, $p, $offset)
.sp
.B &deccvasc($cp, $offset, $len, $np)
.sp
.B &dectoasc($np, $cp, $offset, $len, $right)
.sp
.B &deccvint($integer, $np)
.sp
.B &dectoint($np, $integer)
.sp
.B &deccvlong($lng, $np)
.sp
.B &dectolong($np, $lng)
.sp
.B &deccvflt($flt, $np)
.sp
.B &dectoflt($np, $flt)
.sp
.B &deccvdbl($dbl, $np)
.sp
.B &dectodbl($np, $dbl)
.sp
.B &decadd($n1, $n2, $result)
.sp
.B &decsub($n1, $n2, $result)
.sp
.B &decmul($n1, $n2, $result)
.sp
.B &decdiv($n1, $n2, $result)
.sp
.B &deccmp($n1, $n2)
.sp
.B &deccopy($n1, $n2)
.sp
.B &dececvt($np, $ndigit, $decpt, $sign)
.sp
.B &decfcvt($np, $ndigit, $decpt, $sign)
.sp
.SH LIBRARY FILE
.I cisamperl
comes with a special perl library
.B isam.pl
which contains a few functions to aid in using cisamperl. The
functions in this library are written in 
.I cisamperl
and thus can be modified or extended by the user.
.B isam.pl
uses the 
.B package isam.
.sp
Currently the following functions and definitions are
contained in
.B isam.pl:
.sp
.B &isam'makekey
.br
This function can be used to prepare a variable containg a
.B keydesc
structure for use with &isaddindex, &isstart etc.
.br
.B &isam'getfields
.br
This function can be used to get one or many items of data from a buffer
into a set of variables. The first argument is the variable holding the
buffer, all other parameters form triplets of 
.B position, length and type
for each of the data items to be extracted from the buffer.
.br
.B &isam'setfields
.sp
.SH VARIABLES
.I cisamperl
defines and maintains the following C-ISAM variables:
.sp
$iserrno
.br
$isrecnum
.br
$isstat1
.br
$isstat2
.sp
.SH
.I cisamperl's
C-ISAM interface is based on INFORMIX C-ISAM 3.10 and designed to be linked
with the corresponding libraries only.

.sp
.SH SEE ALSO
perl(1), _Programming Perl_ by Larry Wall and Randal L. Schwarz (ISBN ........),
Informix C-ISAM Programmer's Manual
.sp
.SH BUGS
Surely quite a few
.sp
.SH AUTHOR
Mathias Koerber
.sp
SW International Systems Pte Ltd
.br
14 Science Park Drive, #04-01
.br
The Maxwell
.br
Singapore Science Park
.br
Singapore 0511
.sp
Tel: +65/7780066
.br
Fax: +65/7779401
.sp
e-mail: mathias@solomon.technet.sg
.sp
.SH DISCLAIMER
.I cisamperl
comes without guarantee nor warranty. The author makes no claim as
to its usefulness and/or correctness. You may use this program as you
see fit as long as you don't violate the copyright and the license
given. If the program does you any good,be happy. if not, tough luck.
.sp
.I cisamperl
was written as a private project by the author while at SW International
Systems. Apart from granting the use of their system to do the development,
SW International had no stake nor interest in
.I cisamperl
and thus no affiliation with it. In particular does SW International make
no claim as to its usefulness and correctness and will entertain no
claims concerning 
.I cisamperl. 
.sp
I will (for some time at least) try to maintain 
.I cisamperl.
Thus, please direct bug-reports, suggestions etc to the abovementioned
address. 
