# $Id: isam.pl,v 0.9 1994/10/31 07:10:44 mathias Exp $
#	isam.pl 
#	handling routines for cisamperl / rocisperl
#
#	(C) 1993,1994 Mathias Koerber (Mathias.Koerber@swi.com.sg)
#	see the accompanying file COPYRIGHT for copyright and
#	copying/distribution details
#
#	all routines are in the package isam, and will have to be called
#	with the package name prefixed (to keep the namespace for the
#	normal program clean)
#
# $Log: isam.pl,v $
% Revision 0.9  1994/10/31  07:10:44  mathias
% *** empty log message ***
%
#

require "isam.ph";

package isam;

#	isam'makekey
#
#	this function is used to describe a key for use with isbuild or
#	isaddindex
#
#	It takes the following parameters:
#		1. flags	numeric, the sum of:	&ISNODUPS
#							&ISDUPS
#							&DCOMPRESS
#							&LCOMPRESS
#							&TCOMPRESS
#							&COMPRESS
#							&ISCLUSTER
#
#
#		2. for each part of the key 3 values:
#		   start,
#		   length,
#		   type
#
#
#	EXAMPLE:
#
#	$keydesc{"$filename.$keyname"} =
#		&isam'makekey(&ISDUPS+&COMPRESS,
#				(0,10,&CHARTYPE),
#				(20,&INTSIZE,&INTTYPE));
#		
sub makekey {
	local($flags,$template,$shorts);

	$flags = shift;
	$shorts = $#_+1;
	$template = "ss s24 sl";
	return pack($template,$flags,($shorts/3),@_,0,0);
	}
#
#
#
sub getfields {
	local($buffer,@list) = @_;
	local($temp);
	local($mask);
	local(@result);

	while (($pos,$len,$type) = splice(@list,0,3)) {
		if ($type == &main'CHARTYPE) {
			$mask = "x$pos a$len";
			$temp = unpack($mask,$buffer);
			}
		elsif ($type == &main'INTTYPE) {
			$temp = &main'ldint($buffer,$pos);
			}
		elsif ($type == &main'LONGTYPE) {
			$temp = &main'ldlong($buffer,$pos);
			}
		push(@result,$temp);
		}
	return @result;
	}


sub setfields {
	local(@list) = @_;
	local($temp);

	while (($pos,$len,$type,$value) = splice(@list,0,4)) {
		if ($type == &main'CHARTYPE) {
			&main'stchar($value,$temp,$pos,$len);
			}
		elsif ($type == &main'INTTYPE) {
			&main'stint($value,$temp,$pos);
			}
		elsif ($type == &main'LONGTYPE) {
			&main'stlong($value,$temp,$pos);
			}
		}
	return $temp;
	}
1;
